summaryrefslogtreecommitdiff
blob: f54467ea7e5a905d72b26443b5112194d48045e8 (plain)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
# Copyright 1999-2010 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI=2

inherit eutils versionator

MY_PATCHVER=$(get_version_component_range 1-2)

DESCRIPTION="A high-performance, open source, schema-free document-oriented database"
HOMEPAGE="http://www.mongodb.org"
SRC_URI="http://github.com/mongodb/mongo/tarball/r${PV} -> ${P}.tar.gz"

LICENSE="AGPL-3"
SLOT="0"
KEYWORDS="~amd64 ~x86"
IUSE=""

RDEPEND="dev-lang/spidermonkey
	dev-libs/boost
	dev-libs/libpcre"

DEPEND="${RDEPEND}
	>=dev-util/scons-1.2.0-r1"

S=${WORKDIR}/${PN}-mongo-8a4fb8b

pkg_setup() {
	enewgroup mongodb
	enewuser mongodb -1 -1 /var/lib/${PN} mongodb
}

src_prepare() {
	epatch "${FILESDIR}"/modify-*-${MY_PATCHVER}.patch
}

src_compile() {
	scons ${MAKEOPTS} all || die "Compile failed"
}

src_install() {
	scons ${MAKEOPTS} install --prefix="${D}"/usr || die "Install failed"

	for x in /var/{lib,log,run}/${PN}; do
		dodir "${x}" || die "Install failed"
		fowners mongodb:mongodb "${x}"
	done

	doman debian/mongo*.1 || die "Install failed"

	newinitd "${FILESDIR}/${PN}.initd" ${PN} || die "Install failed"
	newconfd "${FILESDIR}/${PN}.confd" ${PN} || die "Install failed"
}

src_test() {
	scons ${MAKEOPTS} smoke test || die "Tests failed"
}

pkg_preinst() {
	has_version '<dev-db/mongodb-1.2'
	PREVIOUS_LESS_THAN_1_2=$?
}

pkg_postinst() {
	if [[ ${PREVIOUS_LESS_THAN_1_2} -eq 0 ]]; then
		ewarn "You need to upgrade your database before proceeding! Steps:"
		ewarn "   /etc/init.d/mongodb stop"
		ewarn "   mongod --upgrade"
		ewarn "   /etc/init.d/mongodb start"
		ewarn "For more info about upgrading, please visit:"
		ewarn "http://www.mongodb.org/display/DOCS/1.2.0+Release+Notes"
	fi;
}